/*
 * parseconf.c
 *
 * Michal Ludvig <mic@bigfoot.com>
 * started: 25 Aug 1996
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "mic.h"

int parseconf(FILE *f, const char *section, const char *parameter, char *value)
/* Returns:
 *   0 - section/parameter NOT found
 *   1 - YES, 'value' contains valid data
 */
{
	char sect[100],line[100],param[100],temp[100];
	char section2[100];
	int rval=0,i;
	
	fseek(f,0,SEEK_SET);
	
	sprintf(section2,"[%s]",section);
	
	while(!feof(f))
	{
		fgets(temp,100,f);
		sscanf(temp,"%s",sect);
		
		if (sect[0]=='#' || sect[0]==';')
			continue; /* comment */
		
		if ((strcmp(sect,section)==0)||(strcmp(sect,section2)==0))
		{
			while(!feof(f))
			{
				fgets(temp,100,f);
				sscanf(temp,"%s",line);
		
				if (line[0]=='#' || line[0]==';')
					continue; /* comment */
		
				if (line[0]=='[')
					break; /* begining next section */
		
				param[0]='\0';
		
				sscanf(line,"%[^ \t\n\r=]",param);
		
				if (param[0]=='\0')
					continue; /* empty line */
	
				if (strcmp(param,parameter)==0)
				{
					sscanf(temp,"%[^=] = %[^\n#;]",param,value);
					
					i=strlen(value)-1; 
					while((value[i]==' ')||(value[i]=='\n')||(value[i]=='\t'))
							value[i--]='\0';
					
					rval=1;
				}
				else
					continue;
			}
			break;
		}
	}
	
	return rval;
	
} /* of parseconf() */
