#include <ctype.h>
#include <malloc.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include "mic.h"
#include "config.h"
#include "vyroci.h"

#define	debug		printf
#define	debug2	printf

void DelRecord(char *rec, const char *filename)
{
	FILE	*f1,*f2;
	char	line[1000];
	char	fn1[1000],fn2[1000];
	int	n=0;
	
	if((f1=fopen(filename,"r"))==NULL)
		failprog(4,"chyba: Nemohu otevrit soubor '%s' pro cteni (%s)\n",filename,errstr(errno));
	
	sprintf(fn1,"%s.%d",filename,getpid());
	if((f2=fopen(fn1,"w"))==NULL)
		failprog(4,"chyba: Nemohu zalozit soubor '%s' (%s)\n",fn1,errstr(errno));
	
	while(!feof(f1))
	{
		line[0]=0;
		fgets(line,1000,f1);
		if(strncmp(line,rec,strlen(rec)))
			fputs(line,f2);
		else
			n++;
	}
	
	fclose(f1);
	fclose(f2);
	
	rec[strlen(rec)-1]=0;
	if(n)
	{
		sprintf(fn2,"%s-",filename);
		if(rename(filename,fn2))
			failprog(5,"chyba: Nemohu vytvorit zalozni kopii (%s)\n",errstr(errno));
	
		if(rename(fn1,filename))
			failprog(5,"chyba: Nemohu zapsat vysledny soubor (%s)\n",errstr(errno));
		printf("Polozka \"%s\" byla odstranena.\n",rec);
	}
	else
		printf("Polozku \"%s\" jsem v souboru \"%s\" nenasel. (to je divny...)\n",rec,filename);
}

int Delete(const char *filename)
{
	FILE	*f;
	char	buf[200],**ptr;
	int	numlin,rows,n,i,valid;
	
	printf("Smazani polozky ze souboru %s\n",filename);
	
	if((f=fopen(filename,"a+"))==NULL)
		failprog(4,"chyba: Nemohu otevrit soubor '%s' pro cteni+zapis\n",filename);
	
	numlin=0;
	
	fseek(f,0,SEEK_SET);
	
	rows=NumRows()-1;
	
	ptr=calloc(rows,sizeof(char*));
	
	for(i=0;i<rows;i++)
		ptr[i]=malloc(200);
		
	i=0;n=0;valid=0;
	
	while(!feof(f))
	{
		fgets(buf,200,f);
		if(isalnum(buf[0]))
		{
			sprintf(ptr[i],buf);
			i++;
			printf("%d: %s",i,ptr[i-1]);
			if(i+1==rows)
			{
				printf("Smazat zaznam cislo (<Enter>...nic nemazat): ");
				fgets(buf,200,stdin);
				if(sscanf(buf,"%d",&n)==1)
				{
					if(n<i+1 && n>0)
					{
						printf("Byl vybran zaznam: %s",ptr[n-1]);
						if((valid=Question("Smazat [a/N]: ",1,0,0))) break;
					}
					else
						n=0;
				}
				i=0;
			}
		}
		buf[0]=0;
	}
	
	if(!n)
	{
		printf("Smazat zaznam cislo (<Enter>...nic nemazat): ");
		fgets(buf,200,stdin);
		if(sscanf(buf,"%d",&n)==1)
		{
			if(n<i+1 && n>0)
			{	
				printf("Byl vybran zaznam: %s",ptr[n-1]);
				valid=Question("Smazat [a/N]: ",1,0,0);
			}
		}
	}
	
	if(valid)
		DelRecord(ptr[n-1],filename);
	
	fclose(f);
	return 0;
}
