/*
 * util.c - support functions for 'vyroci'
 * Michal Ludvig <michal@ludvig.cz>
 */

#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "vyroci.h"

char	buf[200];

int DayNumInMonth(int month, int year)
/* month = {1, .. ,12} */
{
	switch(month)
	{
		case 4:
		case 6:
		case 9:
		case 11: return 30;
		case 2:  return !(year%400)||(!(year%4)&&(year%100))?29:28;
		default: return 31;
	}
}

long AbsDay(int year, int month, int day)
{
	long	ret;
	int	i;	
	
	if(day>DayNumInMonth(month,year))
		return 0;
	
	ret=0;
	for(i=1;i<month;i++)
		ret+=DayNumInMonth(i,year);
	ret+=day;
	
	year--;
	ret+=year*365+year/4-year/100+year/400;
	return ret;
}

void dummy(const char *str, ...)
{
}

/*
char* Str_vyroci1(int days)
{
	return CzStr_vyroci1(days);
}
*/

char* CzStr_vyroci1(int days)
{
	switch(days)
	{
		case -2:	sprintf(buf,"Predevcirem"); break;
		case -1:	sprintf(buf,"Vcera"); break;
		case  0:	sprintf(buf,"Dnes"); break;
		case  1:	sprintf(buf,"Zitra"); break;
		case  2:
		case  3:
		case  4:	sprintf(buf,"Za %d dny",days); break;
		default:	if(days<0)
						sprintf(buf,"Pred %d dny",-days);
					else
						sprintf(buf,"Za %d dni",days);
	}
	return buf;
}

int Question(const char *q, int y, int n, int nl)
{
	int	valid;
	char	respond[100];
	
	do {
		printf(q);
		gets(respond);
		switch(respond[0])
		{
			case    0:
			case '\n':	valid=nl; break;
			case  'a':
			case  'A':
			case  'y':
			case  'Y':	valid=y; break;
			case  'n':
			case  'N':	valid=n; break;
			default:		valid=-1;
		}
	} while(valid<0);
	
	return valid;
}
